/*
 * 版权信息：
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 * 遵循 Apache License, Version 2.0 许可证
 * http://www.apache.org/licenses/LICENSE-2.0
 */

package net.micode.notes.gtask.remote;

import android.app.Activity;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.IBinder;


// GTaskSyncService 类，用于实现 GTask 的同步服务
public class GTaskSyncService extends Service {
    // 定义同步操作类型的字符串名称
    public final static String ACTION_STRING_NAME = "sync_action_type";
    // 开始同步操作的常量
    public final static int ACTION_START_SYNC = 0;
    // 取消同步操作的常量
    public final static int ACTION_CANCEL_SYNC = 1;
    // 无效操作的常量
    public final static int ACTION_INVALID = 2;
    // 服务广播的名称
    public final static String GTASK_SERVICE_BROADCAST_NAME = "net.micode.notes.gtask.remote.gtask_sync_service";
    // 广播中表示是否正在同步的键
    public final static String GTASK_SERVICE_BROADCAST_IS_SYNCING = "isSyncing";
    // 广播中表示同步进度消息的键
    public final static String GTASK_SERVICE_BROADCAST_PROGRESS_MSG = "progressMsg";


    // 存储同步任务的静态变量
    private static GTaskASyncTask mSyncTask = null;
    // 存储同步进度消息的静态变量
    private static String mSyncProgress = "";


    // 开始同步的方法
    private void startSync() {
        // 如果同步任务为空，则创建一个新的同步任务
        if (mSyncTask == null) {
            mSyncTask = new GTaskASyncTask(this, new GTaskASyncTask.OnCompleteListener() {
                // 同步任务完成后的回调方法
                public void onComplete() {
                    mSyncTask = null;
                    sendBroadcast("");
                    stopSelf();
                }
            });
            sendBroadcast("");
            // 执行同步任务
            mSyncTask.execute();
        }
    }


    // 取消同步的方法
    private void cancelSync() {
        // 如果同步任务不为空，则取消同步任务
        if (mSyncTask!= null) {
            mSyncTask.cancelSync();
        }
    }


    // 服务创建时调用的方法
    @Override
    public void onCreate() {
        mSyncTask = null;
    }


    // 服务启动时调用的方法，根据传入的意图执行不同的操作
    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Bundle bundle = intent.getExtras();
        if (bundle!= null && bundle.containsKey(ACTION_STRING_NAME)) {
            switch (bundle.getInt(ACTION_STRING_NAME, ACTION_INVALID)) {
                // 开始同步操作
                case ACTION_START_SYNC:
                    startSync();
                    break;
                // 取消同步操作
                case ACTION_CANCEL_SYNC:
                    cancelSync();
                    break;
                default:
                    break;
            }
            // 服务被杀死后会自动重启
            return START_STICKY;
        }
        // 调用父类的 onStartCommand 方法
        return super.onStartCommand(intent, flags, startId);
    }


    // 内存不足时调用的方法，如果有同步任务则取消同步任务
    @Override
    public void onLowMemory() {
        if (mSyncTask!= null) {
            mSyncTask.cancelSync();
        }
    }


    // 服务绑定方法，返回 null 表示不支持绑定
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }


    // 发送广播的方法
    public void sendBroadcast(String msg) {
        mSyncProgress = msg;
        Intent intent = new Intent(GTASK_SERVICE_BROADCAST_NAME);
        intent.putExtra(GTASK_SERVICE_BROADCAST_IS_SYNCING, mSyncTask!= null);
        intent.putExtra(GTASK_SERVICE_BROADCAST_PROGRESS_MSG, msg);
        sendBroadcast(intent);
    }


    // 静态方法，开始同步操作，设置活动上下文并启动服务
    public static void startSync(Activity activity) {
        GTaskManager.getInstance().setActivityContext(activity);
        Intent intent = new Intent(activity, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_START_SYNC);
        activity.startService(intent);
    }


    // 静态方法，取消同步操作，发送取消同步的意图并启动服务
    public static void cancelSync(Context context) {
        Intent intent = new Intent(context, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_CANCEL_SYNC);
        context.startService(intent);
    }


    // 静态方法，检查是否正在同步
    public static boolean isSyncing() {
        return mSyncTask!= null;
    }


    // 静态方法，获取同步进度字符串
    public static String getProgressString() {
        return mSyncProgress;
    }
}